package FourierPackage;

public class Punkt {

    /**
     * x-Wert des Punktes
     */
    public double x;

    /**
     * y-Wert des Punktes
     */
    public double y;


    /**
     * Neuer Punkt mit Koordinatenwerten x und y wird erzeugt.
     * @param x x-Wert des Punktes
     * @param y y-Wert des Punktes
     */
    Punkt(double x, double y) {
        this.x = x;
        this.y = y;
    }



    /**
     * Liefert x-Wert des Punktes.
     *
     * @return x-Wert des Punktes
     */
    public double getX() {
        return x;
    }

    /**
     * Liefert y-Wert des Punktes.
     *
     * @return y-Wert des Punktes
     */
    public double getY() {
        return y;
    }

    /**
     * Setzt x-Wert des Punktes.
     *
     * @param f x-Wert des Punktes
     */
    public void setX(double f) {
        x = f;
    }

    /**
     * Setzt y-Wert des Punktes.
     *
     * @param f y-Wert des Punktes
     */
    public void setY(double f) {
        y = f;
    }
}
