/*
 * Coordinates.java
 *
 * Created on 20. November 2008, 10:58
 */

package FourierPackage;


import java.awt.*;
import java.awt.event.MouseEvent;
import javax.swing.JPanel;
import java.awt.MouseInfo;
import java.awt.PointerInfo;
import java.awt.event.InputEvent;
import java.awt.Cursor;
//import java.util.*;
//import java.applet.*;
//import java.net.URL;


/**
 *
 * @author  Los Wufflos
 */
public class RechteckMain extends JPanel {


//  Graphics g;

    java.awt.Graphics2D g2d;
    EasyCoord EC;
    CoordPlane CoordSystem;


    int PanelW,PanelH;
    private int Amplitude=0,Amount=0,Xoffset=0, Yoffset=0, Period=1;
    private int XMin=-10, XMax=10,Ymax=5,Ymin=-5;
    private int type=0;
    private static int function=0;
    private static boolean MarkFlag=false;
    private static Punkt MarkPunkt,tmpPunkt,tmpPunktsin,tmpPunktexp,tmpPunktpoly;
    private boolean ClickMark=false;
    private boolean KeinPunkt=true;
    private boolean crossCursor = false;

    public static LinkedPointList pl = new LinkedPointList();
    public static LinkedPointList plsin = new LinkedPointList();
    public static LinkedPointList plexp = new LinkedPointList();
    public static LinkedPointList plpoly = new LinkedPointList();
    Stroke strokeThin = new BasicStroke( 1 );
    Stroke strokeThick = new BasicStroke( 2 );

    static double PunkteYMAX;
    static double sinYMAX;
    static double expYMAX;
    static double polyYMAX;


    /** Creates new form Coordinates */
    public RechteckMain() {
        initComponents();
        CoordSystem = new CoordPlane();
        CoordSystem.setType(type);





    }

    public boolean getCursorStatus() {
        return crossCursor;
    }

    public void setPanelSize(int height, int width) {
        PanelW=width;
        PanelH=height;
        CoordSystem.setCoordSeize(height, width, XMin, XMax);
    }

    public void setPanelSize(int height, int width,double ymax) {

        PanelW=width;
        PanelH=height;
        CoordSystem.setCoordSeize(height, width, XMin, XMax, ymax);
    }



    public void setAmount(int a) {
        Amount = a;
    }

    public void setAmplitude(int a) {
        Amplitude = a;
    }

    public void setXMIN(int val) {
        XMin = val;
    }

    public void setXMAX(int val) {
        XMax = val;
    }
    public void setYMAX(int val) {
        Ymax = val;
    }
    public void setYMIN(int val) {
        Ymin = val;
    }


    public void setXoffset(int val) {
        Xoffset = val;
    }


    public void setYoffset(int val) {
        Yoffset = val;
    }

    public void setT(int val) {
        Period = val;
    }

    public void setFunction(int val) {
        function = val;
    }

    public int getFunction() {
        return function;
    }

    public void setType(int typ) {
        type = typ;
    }

    public void reset() {
        PunkteYMAX=1;
        sinYMAX=1;
        expYMAX=1;
        polyYMAX=1;
    }

    public void setMarkFlag(boolean a) {
        MarkFlag = a;
    }
    public void setMarkPunkt(Punkt p) {
        MarkPunkt = p;
    }

    public Punkt getMarkPunkt() {
        return MarkPunkt;
    }

    @Override
    public void paintComponent(Graphics g) {
        g2d = (Graphics2D) g;
        g2d.setStroke(strokeThin);
        if(type ==0) {
            CoordSystem.clear(g);
            CoordSystem.paint(g);
            CoordSystem.setType(0);
        } else if(type ==1) {
            CoordSystem.clear(g);
            CoordSystem.paint2(g);//normal 2
            CoordSystem.setType(1);
        }

        // CoordSystem2.clear(g);
        // CoordSystem2.paint(g);


        g.setColor(Color.RED);
        repaint();





        if(type==0) {

            if(function == 0) {
                //g2d.setStroke(strokeThin);
                int[][] values = CoordSystem.lagrange(pl.getXKoords(),pl.getYKoords());

                g.setColor(Color.BLUE);
                if(pl.getAnzahlPunkte()!=0)
                    g.drawPolyline(values[0],values[1], values[1].length);


                CoordSystem.Punkteumrechnen(pl.getXKoords(),pl.getYKoords(),g);
                if(MarkFlag == true&&pl.getAnzahlPunkte()<=20)
                    CoordSystem.PunktMark(MarkPunkt.x, MarkPunkt.y, g);
            } else if (function == 1) {
                //g2d.setStroke(strokeThick);
                int[][] values = CoordSystem.sin();
                g.drawPolyline(values[0],values[1], values[1].length);
                //g2d.setStroke(strokeThin);
                g.setColor(Color.BLUE);
                if(plsin.getAnzahlPunkte()!=0) {
                    int[][] values2 = CoordSystem.lagrange(plsin.getXKoords(),plsin.getYKoords());
                    g.drawPolyline(values2[0],values2[1], values2[1].length);
                }

                CoordSystem.Punkteumrechnen(plsin.getXKoords(),plsin.getYKoords(),g);
                if(MarkFlag == true)// &&plsin.getAnzahlPunkte()<=20)
                    CoordSystem.PunktMark(MarkPunkt.x, MarkPunkt.y, g);

            } else if (function == 2) {
                //g2d.setStroke(strokeThick);
                int[][] values = CoordSystem.exp();
                g.drawPolyline(values[0],values[1], values[1].length);
                g.setColor(Color.BLUE);
                //g2d.setStroke(strokeThin);
                if(plexp.getAnzahlPunkte()!=0) {
                    int[][] values2 = CoordSystem.lagrange(plexp.getXKoords(),plexp.getYKoords());
                    g.drawPolyline(values2[0],values2[1], values2[1].length);
                }

                CoordSystem.Punkteumrechnen(plexp.getXKoords(),plexp.getYKoords(),g);
                if(MarkFlag == true&&plexp.getAnzahlPunkte()<=20)
                    CoordSystem.PunktMark(MarkPunkt.x, MarkPunkt.y, g);
            } else if (function == 3) {
                //g2d.setStroke(strokeThick);
                int[][] values = CoordSystem.polynom();
                g.drawPolyline(values[0],values[1], values[1].length);
                g.setColor(Color.BLUE);
                //g2d.setStroke(strokeThin);
                if(plpoly.getAnzahlPunkte()!=0) {
                    int[][] values2 = CoordSystem.lagrange(plpoly.getXKoords(),plpoly.getYKoords());
                    g.drawPolyline(values2[0],values2[1], values2[1].length);
                }

                CoordSystem.Punkteumrechnen(plpoly.getXKoords(),plpoly.getYKoords(),g);
                if(MarkFlag == true&&plpoly.getAnzahlPunkte()<=20)
                    CoordSystem.PunktMark(MarkPunkt.x, MarkPunkt.y, g);
            }

        }


        else if(type==1) {
            CoordSystem.setType(1);
            //CoordSystem.setY(15,-0.3);
            /*
            for(int iz=0;iz< punkte.length;iz++){
            System.out.println("punkte["+iz+"] entspricht x^"+iz+" = "+punkte[iz]);
            }
            */
            if(function == 0) {


                double[] punkte = CoordSystem.lagKoeffizienten(pl.getXKoords(),pl.getYKoords());
                if(pl.getAnzahlPunkte()!=0) {
                    for(int i=0; i<pl.getAnzahlPunkte(); i++) {

                        if (Math.sqrt(punkte[i]*punkte[i])>PunkteYMAX)
                            PunkteYMAX =Math.sqrt(punkte[i]*punkte[i]);
                        CoordSystem.Balken(punkte[i], i, g);
                        CoordSystem.setCoordSeize(PanelH, PanelW, XMin, XMax,PunkteYMAX*1.1);
                        //System.out.println("Übergabeparameter an setCoordSeize (für panel2): "+PunkteYMAX*1.1);

                    }
                } else CoordSystem.setCoordSeize(PanelH, PanelW, XMin, XMax, 2.5);
            }





            else if(function == 1) {
                double[] sin = CoordSystem.lagKoeffizienten(plsin.getXKoords(),plsin.getYKoords());
                if(plsin.getAnzahlPunkte()!=0) {
                    for(int i=0; i<plsin.getAnzahlPunkte(); i++) {
                        if (Math.sqrt(sin[i]*sin[i])>sinYMAX)
                            sinYMAX =Math.sqrt(sin[i]*sin[i]);
                        CoordSystem.Balken(sin[i], i, g);

                        CoordSystem.setCoordSeize(PanelH, PanelW, XMin, XMax, (int)1.1*sinYMAX+0.5);
                    }

                } else CoordSystem.setCoordSeize(PanelH, PanelW, XMin, XMax, 2.5);
            } else if(function == 2) {
                double[] exp = CoordSystem.lagKoeffizienten(plexp.getXKoords(),plexp.getYKoords());
                if(plexp.getAnzahlPunkte()!=0) {
                    for(int i=0; i<plexp.getAnzahlPunkte(); i++) {

                        if (Math.sqrt(exp[i]*exp[i])>expYMAX)
                            expYMAX =Math.sqrt(exp[i]*exp[i]);
                        CoordSystem.Balken(exp[i], i, g);
                        CoordSystem.setCoordSeize(PanelH, PanelW, XMin, XMax, (int)1.1*expYMAX+0.5);

                    }

                } else CoordSystem.setCoordSeize(PanelH, PanelW, XMin, XMax, 2.5);
            } else if(function == 3) {
                double[] poly = CoordSystem.lagKoeffizienten(plpoly.getXKoords(),plpoly.getYKoords());
                if(plpoly.getAnzahlPunkte()!=0) {
                    for(int i=0; i<plpoly.getAnzahlPunkte(); i++) {


                        if (Math.sqrt(poly[i]*poly[i])>polyYMAX)
                            polyYMAX =Math.sqrt(poly[i]*poly[i]);

                        CoordSystem.Balken(poly[i], i, g);

                        CoordSystem.setCoordSeize(PanelH, PanelW, XMin, XMax, (int)1.1*polyYMAX+0.5);
                    }

                } else CoordSystem.setCoordSeize(PanelH, PanelW, XMin, XMax, 2.5);
            }

        }



    }




    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setPreferredSize(new java.awt.Dimension(400, 200));
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                formMousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                formMouseReleased(evt);
            }
        });
        addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                formMouseDragged(evt);
            }
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                formMouseMoved(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 200, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    /*
    class MyMouseListener extends MouseAdapter
    	{

    	/**
    	 * Methode wird aufgerufen, falls Maustaste gedr�ckt wurde
    	 *
    	 * @param evt 	MouseEvent

    	public void mousePressed(MouseEvent evt)
    		{
    		// Mausposition holen
    		int posX = evt.getX();
    */

    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked

    }//GEN-LAST:event_formMouseClicked

    private void formMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseMoved
        // TODO add your handling code here:
    }//GEN-LAST:event_formMouseMoved

    private void formMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseDragged

    }//GEN-LAST:event_formMouseDragged

    private void formMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMousePressed
        if(type==0) {
            crossCursor=true;

            if(evt.getButton()==1) {
                if(function == 0) {

                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.calcValueY(evt.getY()));
                    tmpPunkt=p;
                    if(pl.check(p)==0)
                        KeinPunkt=true;
                    else if(pl.check(p)>0) {
                        MarkPunkt = pl.getPunkt(pl.check(p));
                        KeinPunkt=false;
                    }
                }

                else if(function == 1) {

                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.singetYPunkt(CoordSystem.calcValueX(evt.getX())));
                    tmpPunkt=p;
                    if(plsin.check(p)==0)
                        KeinPunkt=true;
                    else if(plsin.check(p)>0) {
                        MarkPunkt = plsin.getPunkt(plsin.check(p));
                        KeinPunkt=false;
                    }
                } else if(function == 2) {

                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.expgetYPunkt(CoordSystem.calcValueX(evt.getX())));
                    tmpPunkt=p;
                    if(plexp.check(p)==0)
                        KeinPunkt=true;
                    else if(plexp.check(p)>0) {
                        MarkPunkt = plexp.getPunkt(plexp.check(p));
                        KeinPunkt=false;
                    }
                } else if(function == 3) {

                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.polynomgetYPunkt(CoordSystem.calcValueX(evt.getX())));
                    tmpPunkt=p;
                    if(plpoly.check(p)==0)
                        KeinPunkt=true;
                    else if(plpoly.check(p)>0) {
                        MarkPunkt = plpoly.getPunkt(plpoly.check(p));
                        KeinPunkt=false;
                    }
                }

                reset();
                repaint();
            } else {

                if(function == 0) {
                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.calcValueY(evt.getY()));
                    if(MarkPunkt==p)
                        MarkFlag=false;
                    if ((pl.check(p))!=0)
                        pl.delPunkt(pl.check(p));
                } else if(function == 1) {

                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.singetYPunkt(CoordSystem.calcValueX(evt.getX())));
                    if(MarkPunkt==p)
                        MarkFlag=false;
                    if ((plsin.check(p))!=0)
                        plsin.delPunkt(plsin.check(p));

                } else if(function == 2) {
                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.expgetYPunkt(CoordSystem.calcValueX(evt.getX())));
                    if(MarkPunkt==p)
                        MarkFlag=false;
                    if ((plexp.check(p))!=0)
                        plexp.delPunkt(plexp.check(p));

                } else if(function == 3) {
                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.polynomgetYPunkt(CoordSystem.calcValueX(evt.getX())));
                    if(MarkPunkt==p)
                        MarkFlag=false;
                    if ((plpoly.check(p))!=0)
                        plpoly.delPunkt(plpoly.check(p));

                }
                reset();
                repaint();
            }
        }
    }//GEN-LAST:event_formMousePressed

    private void formMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseReleased
        //beim loslassen des mausbuttons wird ein punkt gesetzt
        if(type==0) {
            crossCursor=false;
            if(evt.getButton()==1) {

                if(function == 0) {
                    if(pl.getAnzahlPunkte()<20) {
                        Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.calcValueY(evt.getY()));

                        if(KeinPunkt==true&&pl.equalsTol(tmpPunkt, p)) {

                            if((pl.check(p)==0)) {
                                MarkPunkt = p;
                                MarkFlag = true;
                                pl.sadd(p);
                            }

                            else  {
                                // if(pl.getAnzahlPunkte()<20)
                                MarkPunkt = pl.getPunkt(pl.check(p));
                                MarkFlag = true;
                            }

                        } else if(KeinPunkt==true&&(pl.equalsTol(tmpPunkt, p)==false)) {

                        }

                        else {
                            if(pl.check(p)==0) {
                                MarkPunkt = p;
                                MarkFlag = true;
                                pl.sadd(p);
                                pl.delPunkt(pl.check(tmpPunkt));
                            } else {
                                MarkPunkt = pl.getPunkt(pl.check(p));
                                MarkFlag = true;
                            }


                        }
                    }
                }

                else if(function == 1) {
                    if(plsin.getAnzahlPunkte()<20) {
                        Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.singetYPunkt(CoordSystem.calcValueX(evt.getX())));

                        if(KeinPunkt==true&&plsin.equalsTol(tmpPunkt, p)) {

                            if((plsin.check(p)==0)) {
                                MarkPunkt = p;
                                MarkFlag = true;
                                plsin.sadd(p);
                            }

                            else  {
                                MarkPunkt = plsin.getPunkt(plsin.check(p));
                                MarkFlag = true;
                            }

                        } else if(KeinPunkt==true&&(plsin.equalsTol(tmpPunkt, p)==false)) {

                        }

                        else {
                            if(plsin.check(p)==0) {
                                MarkPunkt = p;
                                MarkFlag = true;
                                plsin.sadd(p);
                                plsin.delPunkt(plsin.check(tmpPunkt));
                            } else {
                                MarkPunkt = plsin.getPunkt(plsin.check(p));
                                MarkFlag = true;
                            }


                        }
                    }
                } else if(function == 2) {
                    if(plexp.getAnzahlPunkte()<20) {
                        Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.expgetYPunkt(CoordSystem.calcValueX(evt.getX())));

                        if(KeinPunkt==true&&plexp.equalsTol(tmpPunkt, p)) {

                            if((plexp.check(p)==0)) {
                                MarkPunkt = p;
                                MarkFlag = true;
                                plexp.sadd(p);
                            }

                            else  {
                                MarkPunkt = plexp.getPunkt(plexp.check(p));
                                MarkFlag = true;
                            }

                        } else if(KeinPunkt==true&&(plexp.equalsTol(tmpPunkt, p)==false)) {

                        }

                        else {
                            if(plexp.check(p)==0) {
                                MarkPunkt = p;
                                MarkFlag = true;
                                plexp.sadd(p);
                                plexp.delPunkt(plexp.check(tmpPunkt));
                            } else {
                                MarkPunkt = plexp.getPunkt(plexp.check(p));
                                MarkFlag = true;
                            }


                        }
                    }
                } else if(function == 3) {
                    if(plpoly.getAnzahlPunkte()<20) {
                        Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.polynomgetYPunkt(CoordSystem.calcValueX(evt.getX())));


                        if(KeinPunkt==true&&plpoly.equalsTol(tmpPunkt, p)) {

                            if((plpoly.check(p)==0)) {
                                MarkPunkt = p;
                                MarkFlag = true;
                                plpoly.sadd(p);
                            }

                            else  {
                                MarkPunkt = plpoly.getPunkt(plpoly.check(p));
                                MarkFlag = true;
                            }

                        } else if(KeinPunkt==true&&(plpoly.equalsTol(tmpPunkt, p)==false)) {

                        }

                        else {
                            if(plpoly.check(p)==0) {
                                MarkPunkt = p;
                                MarkFlag = true;
                                plpoly.sadd(p);
                                plpoly.delPunkt(plpoly.check(tmpPunkt));
                            } else {
                                MarkPunkt = plpoly.getPunkt(plpoly.check(p));
                                MarkFlag = true;
                            }


                        }
                    }
                }

                reset();
                repaint();
            } else {
                if(function == 0) {
                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.calcValueY(evt.getY()));
                    if(pl.equalsTol(MarkPunkt, p)) {
                        MarkPunkt = p;
                        MarkFlag=false;
                    }
                    if ((pl.check(p))!=0)
                        pl.delPunkt(pl.check(p));

                } else if(function == 1) {

                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.singetYPunkt(CoordSystem.calcValueX(evt.getX())));
                    if(plsin.equalsTol(MarkPunkt, p)) {
                        MarkPunkt = p;
                        MarkFlag=false;
                    }
                    if ((plsin.check(p))!=0)
                        plsin.delPunkt(plsin.check(p));

                } else if(function == 2) {
                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.expgetYPunkt(CoordSystem.calcValueX(evt.getX())));
                    if(plexp.equalsTol(MarkPunkt, p)) {
                        MarkPunkt = p;
                        MarkFlag=false;
                    }
                    if ((plexp.check(p))!=0)
                        plexp.delPunkt(plexp.check(p));

                } else if(function == 3) {
                    Punkt p = new Punkt(CoordSystem.calcValueX(evt.getX()),CoordSystem.polynomgetYPunkt(CoordSystem.calcValueX(evt.getX())));
                    if(plpoly.equalsTol(MarkPunkt, p)) {
                        MarkPunkt = p;
                        MarkFlag=false;
                    }
                    if ((plpoly.check(p))!=0)
                        plpoly.delPunkt(plpoly.check(p));
                }
                reset();
                repaint();
            }

        }//GEN-LAST:event_formMouseReleased
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
