package Conic1;

public class Linecut {

    double centre_x = 0;
    double centre_y = 0;
    double centre_x1 = 0;
    double centre_y1 =0;

    Determinant1 det = new Determinant1();

    double b11 = 0;
    double b22 = 0;
    double b13 = 0;
    double b23 = 0;
    double b33 = 0;
    double angle = 0;
    double rest = 0;

    double endX_neg = -9.0;
    double endX_pos = 9.0;
    double endY_neg = -9.0;
    double endY_pos = 9.0;

    static double[] x_asym = new double[4];
    static double[] y_asym = new double[4];

    double evalZero(double value)

    {
        double temp = Math.abs(value);
        int compare = Double.compare(temp, 0.001);
        if(compare < 0) {
            value = 0;
        }
        System.out.println("value:"+value);
        return value;
    }

    public Linecut (double a,double b,double c,double d,double e,double f) {
        Conic.cb_scaley.setEnabled(true);

        endX_neg = Draw.endX_neg;
        endX_pos = Draw.endX_pos;
        endY_neg = Draw.endY_neg;
        endY_pos = Draw.endY_pos;

        int comp_d = Double.compare(a, c);
        if(comp_d == 0) {
            if((int)b <0) {
                angle  = -Math.PI/4;
            } else {
                angle  = Math.PI/4;
            }
        } else {
            angle = (Math.atan(b/(a-c)))/2;
        }

        b11 = a*Math.cos(angle)*Math.cos(angle)+ b*Math.sin(angle)*Math.cos(angle)
              + c*Math.sin(angle)*Math.sin(angle);
        b22 = a*Math.sin(angle)*Math.sin(angle)- b*Math.sin(angle)*Math.cos(angle)
              + c*Math.cos(angle)*Math.cos(angle);
        b13 = d/2*Math.cos(angle) + e/2*Math.sin(angle);
        b23 = -d/2*Math.sin(angle) + e/2*Math.cos(angle);
        b33 = f;

        b11 = evalZero(b11);
        b22 = evalZero(b22);
        b13 = evalZero(b13);
        b23 = evalZero(b23);
        b33 = evalZero(b33);
        rest = ( b13*b13/b11 + b23*b23/b22 -b33);    ///(b11*b22);
        rest = det.testRound(rest, 4);


        centre_x = -b13/b11;
        centre_y = -b23/b22;

        centre_x1 = Rotate.rotatedX(centre_x, centre_y, angle);
        centre_y1 = Rotate.rotatedY(centre_x, centre_y, angle);

        double um = b13/b11;
        double vm = b23/b22;

        if(Math.abs(centre_x)== 0.0) {
            centre_x = 0.0;
        }
        if(Math.abs(centre_y)== 0.0) {
            centre_y = 0.0;
        }

        double a_sqrt;
        double b_sqrt;
        double a_hy = 0;
        double b_hy = 0;
        a_hy = 1/b11;
        b_hy = 1/b22;

        a_sqrt = Math.sqrt(Math.abs(a_hy));
        b_sqrt = Math.sqrt(Math.abs(b_hy));

        int comp = Double.compare(a_hy, b_hy);

        if(comp>0) {
            double cut = centre_y -(b_sqrt/a_sqrt)*centre_x;

            double yasym = b_sqrt/a_sqrt * endX_neg + cut;
            x_asym[0] = Rotate.rotatedX(endX_neg, yasym, angle);
            y_asym[0] = Rotate.rotatedY(endX_neg, yasym, angle);
            yasym = b_sqrt/a_sqrt * endX_pos + cut;
            x_asym[1] = Rotate.rotatedX(endX_pos, yasym, angle);
            y_asym[1] = Rotate.rotatedY(endX_pos, yasym, angle);

            cut = centre_y + b_sqrt/a_sqrt*centre_x;
            yasym = -b_sqrt/a_sqrt * endX_neg + cut;
            x_asym[2] = Rotate.rotatedX(endX_neg, yasym, angle);
            y_asym[2] = Rotate.rotatedY(endX_neg, yasym, angle);
            yasym = -b_sqrt/a_sqrt * endX_pos + cut;
            x_asym[3] = Rotate.rotatedX(endX_pos, yasym, angle);
            y_asym[3] = Rotate.rotatedY(endX_pos, yasym, angle);

        } else {
            double cut = centre_y -(b_sqrt/a_sqrt)*centre_x;

            double yasym = b_sqrt/a_sqrt * endX_neg + cut;
            x_asym[0] = Rotate.rotatedX(endX_neg, yasym, angle);
            y_asym[0] = Rotate.rotatedY(endX_neg, yasym, angle);
            yasym = b_sqrt/a_sqrt * endX_pos + cut;
            x_asym[1] = Rotate.rotatedX(endX_pos, yasym, angle);
            y_asym[1] = Rotate.rotatedY(endX_pos, yasym, angle);

            cut = centre_y + b_sqrt/a_sqrt*centre_x;
            yasym = -b_sqrt/a_sqrt * endX_neg + cut;
            x_asym[2] = Rotate.rotatedX(endX_neg, yasym, angle);
            y_asym[2] = Rotate.rotatedY(endX_neg, yasym, angle);
            yasym = -b_sqrt/a_sqrt * endX_pos + cut;
            x_asym[3] = Rotate.rotatedX(endX_pos, yasym, angle);
            y_asym[3] = Rotate.rotatedY(endX_pos, yasym, angle);

        }

        System.out.println("b11: "+b11+" b22: "+b22+" b13: "+b13+" b23: "+b23+" angle"+angle);
        System.out.println("rest: "+rest);
    }

}
