package Conic1;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.ImageIcon;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.SwingConstants;

import javax.imageio.ImageIO;
import java.io.IOException;

public class StartApplet extends JApplet {

    private static final long serialVersionUID = 1L;

    private JButton buttonStart;
    private static ImageIcon iconLogo = null;
    private static ImageIcon symbolPressedLogo[];
    private static ImageIcon symbolUnPressedLogo[];

    private Adapter adapter = new Adapter();

    private Color bgcolor;

    public void init() {
        // Referenz fr weitere Aktionen
        //applet = this;

        /**
         * Hintergrundfarbe, selbe Farbe wie HTML zuweisen
         */
        bgcolor = new Color(235,238,247);

        /**
         * "Null"-Layout verwenden
         */
        getContentPane().setLayout(null);

        /**
         * Hintergrundfarbe setzen
         */
        getContentPane().setBackground(bgcolor);

		try{
			iconLogo = new ImageIcon(ImageIO.read(Conic.class.getResourceAsStream("/images/rsz_kegelschnitt.gif")));
		}catch(IOException ioe){
		}

        buttonStart = new JButton("Applet", iconLogo);
        buttonStart.setBackground(bgcolor);
        buttonStart.setFont(new Font("Sans Serif", Font.BOLD, 10));
        buttonStart.setHorizontalAlignment(SwingConstants.LEFT);
        buttonStart.setIconTextGap(20);
        buttonStart.addActionListener(adapter);
        buttonStart.setBounds(10,10,300,120);
        buttonStart.addMouseListener(new MouseAdapter() {
            public void mouseEntered(MouseEvent evt) {
                setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
            }

            public void mouseExited(MouseEvent evt) {
                setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
            }
        });
        getContentPane().add(buttonStart);

    }
    public static ImageIcon getIconLogo() {
        return iconLogo;
    }
    public static ImageIcon [] getsymbolPressedLogo() {
        return symbolPressedLogo;
    }
    public static ImageIcon [] getsymbolUnPressedLogo() {
        return symbolUnPressedLogo;
    }
    public void start() {
    }
    public void stop() {
    }
    class Adapter extends WindowAdapter implements ActionListener {
        // * Methode wird aufgerufen, falls Fenster in welchem Applet
        // * abluft geschlossen wird.

        public void windowClosing(WindowEvent evt) {
        }

        // * Methode wird aufgerufen, falls mit der Maus auf Button
        //* "Start Applet" geklickt wurde.

        public void actionPerformed(ActionEvent evt) {
            //Start-Button wurde geklickt.
            if (evt.getSource() == buttonStart) {
                //Es wird ein neues Fenster geffnet,
                //und alle Icons bergeben, welche geladen werden sollen.
                Conic.main(null);
            }
        }
    }



}
