package KiP_v3;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.swing.UIManager;

import javax.imageio.ImageIO;
import java.io.IOException;

/**
 * Klasse Polarkoordinaten
 * Enthlt Einstiegspunkt fr Java Programme
 * Erzeugt das Hauptfenster
 * @author Florian Pahling 17/03/2008
 */
public class Polarkoordinaten {
    /**
     * Hauptfenster
     */
    private static JFrame Hauptfenster;

    /**
     * Thread welcher das Fenster nach festgelegter Zeit neu zeichnet
     */
    private static RepaintThread thread;

    /**
     * legt fest ob Applet oder nicht
     */
    private static boolean IsApplet = true;

    /**
     * Zeiger auf Logos
     */
    private static ImageIcon iconLogo = null;
    private static ImageIcon symbolPressedLogo[];
    private static ImageIcon symbolUnPressedLogo[];
    private static ImageIcon symbolClose = null;
//		private static ImageIcon symbolAbout = null;


    /**
     * Zeiger auf Bilder die eingeblendet werden knnen
     */
    private static ImageIcon FunkBild1 = null;

    /**
     * Iconleiste
     */
    private static ToolBar toolbar  = null;

    /**
     * Men
     */
    private static Fenstermenue fenstermenue = null;

    /**
     * Standart Fenstergre
     */
    private static final int groesseHauptfenster_X = 830;


    /**
     * Referenz auf das Applet
     */
    private static JApplet applet = null;

    //---------------------------------------------------------------------------


    /**
     * leifert Zeiger auf Logo
     */
    public static ImageIcon getIconLogo() {
        return iconLogo;
    }

    /**
     * leifert Zeiger auf Bild der Funktion01
     */
    public static ImageIcon getFunkBild1() {
        return FunkBild1;
    }

    /**
     * leifert Zeiger auf gedrcktes Symbol
     */
    public static ImageIcon getsymbolPressedLogo(int nr) {
        return symbolPressedLogo[nr];
    }

    /**
     * leifert Zeiger auf nicht gedrcktes Symbol
     */
    public static ImageIcon getsymbolUnPressedLogo(int nr) {
        return symbolUnPressedLogo[nr];
    }

    /**
     * leifert Zeiger auf Close Symbol
     */
    public static ImageIcon getsymbolClose() {
        Polarkoordinaten oObj=new Polarkoordinaten();
        Class oClass=oObj.getClass();

        //return symbolClose = new ImageIcon(Polarkoordinaten.class.getResource("/images/Beenden_Knopf.png"));
		
		try{
			return symbolClose = new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/Beenden_Knopf.png")));
		}catch(IOException ioe){
		}	
		
		return symbolClose;
    }

//		/**
//		 * leifert Zeiger auf About Symbol
//		 */
//		public static ImageIcon getsymbolAbout()
//		{
//			Polarkoordinaten oObj=new Polarkoordinaten();
//			Class oClass=oObj.getClass();
//
//			return symbolAbout = new ImageIcon((URL)oClass.getResource("images/about.png"));
//		}

    /**
     * Einsprungspunkt fr java Programme
     *
     * @param args Argumente (werden nicht bercksichtigt)
     */
    public static void main( String args[] ) {
        // kein Applet
        IsApplet = false;

        // Icon Arrays anlegen
        symbolPressedLogo = new ImageIcon[3];
        symbolUnPressedLogo = new ImageIcon[3];
		
        Polarkoordinaten oObj=new Polarkoordinaten();
        Class oClass=oObj.getClass();

		try{
			symbolPressedLogo[0] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func01_is_aktiv.png")));
			symbolUnPressedLogo[0] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func01_not_aktiv.png")));
			symbolPressedLogo[1] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func02_is_aktiv.png")));
			symbolUnPressedLogo[1] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func02_not_aktiv.png")));
			symbolPressedLogo[2] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func03_is_aktiv.png")));
			symbolUnPressedLogo[2] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func03_not_aktiv.png")));
			
			// iconLogo laden
			//iconLogo = new ImageIcon("images/polar.gif");
			iconLogo = new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/polar.gif")));
			
			// Optional Bild der Funktion laden momentan Transparent
			FunkBild1 = new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/Transparent.png")));	
			
		}catch(IOException ioe){
		}


       
        

        

        // starten
        Haupt_Programm();
    }



    /**
     * Einsprungspunkt fr javaApplets
     *
     * @param a Referernz des Applets
     */
    public static void main1(JApplet a) {
        // Logo kommt vom Applet

        iconLogo = StartApplet.getIconLogo();
        symbolPressedLogo = StartApplet.getsymbolPressedLogo();
        symbolUnPressedLogo = StartApplet.getsymbolUnPressedLogo();

        // Icon Arrays anlegen
        symbolPressedLogo = new ImageIcon[3];
        symbolUnPressedLogo = new ImageIcon[3];

        Polarkoordinaten oObj=new Polarkoordinaten();
        Class oClass=oObj.getClass();

        try{
			symbolPressedLogo[0] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func01_is_aktiv.png")));
			symbolUnPressedLogo[0] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func01_not_aktiv.png")));
			symbolPressedLogo[1] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func02_is_aktiv.png")));
			symbolUnPressedLogo[1] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func02_not_aktiv.png")));
			symbolPressedLogo[2] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func03_is_aktiv.png")));
			symbolUnPressedLogo[2] 	= new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/func03_not_aktiv.png")));
			
			// iconLogo laden
			//iconLogo = new ImageIcon("images/polar.gif");
			iconLogo = new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/polar.gif")));
			
			// Optional Bild der Funktion laden momentan Transparent
			FunkBild1 = new ImageIcon(ImageIO.read(Polarkoordinaten.class.getResourceAsStream("/images/Transparent.png")));	
			
		}catch(IOException ioe){
		}
		
        applet = a;

        // starten
        Haupt_Programm();
    }

    /**
     * eigentlicher Einsprungspunkt fr's Programm
     */
    private static void Haupt_Programm() {

        // Look & Feel einstellen
        try {
            // UIManager.setLookAndFeel( UIManager.getCrossPlatformLookAndFeelClassName() );
            // UIManager.setLookAndFeel( "javax.swing.plaf.metal.MetalLookAndFeel" );
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
            //      UIManager.setLookAndFeel( "com.l2fprod.gui.plaf.skin.SkinLookAndFeel" );
            //      UIManager.setLookAndFeel( UIManager.getSystemLookAndFeelClassName() );
        } catch ( Exception e ) {
            e.printStackTrace();
        }

        // Hauptfenster erzeugen
        Hauptfenster = new JFrame( "Kurven in Polarkoordinaten" );
        // Java Programme sofort beenden
        if (!IsApplet) Hauptfenster.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );

        // Tool Bar erzeugen und zum Fenster hinzufgen
        toolbar = new ToolBar(Hauptfenster, IsApplet);
        toolbar.addToFrame();

        //Menu erzeugen
        fenstermenue = new Fenstermenue(Hauptfenster, IsApplet, applet);

        // Gre vom Hauptfenster festlegen

        Hauptfenster.setSize( groesseHauptfenster_X , groesseHauptfenster_X*3/4);

        //Minimale gre vom Hauptfensterfestlegen

        Hauptfenster.setMinimumSize(new java.awt.Dimension(580,485));

        // Hauptfenster in Bildschirmmitte positionieren
        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        int xPos = dim.width/2 - Hauptfenster.getWidth()/2;
        int yPos = dim.height/2 - Hauptfenster.getHeight()/2;
        Hauptfenster.setLocation(xPos, yPos);


        // bei Grennderung neu zeichnen
        Hauptfenster.addComponentListener(
            new ComponentAdapter()

        {
            public void componentResized( ComponentEvent event ) {
                if ( event.getID() == 	ComponentEvent.COMPONENT_RESIZED ) {
                    if (toolbar != null ) toolbar.doRepaint();
                }
            }
        }
        );


        // repaint Thread erzeugen und starten
        thread= new RepaintThread();
        thread.start();

        // Hauptfenster anzeigen
        Hauptfenster.setVisible( true );
    }


    /**
     * Setzt die gewnschte Darstellungsart auf der Toolbar
     *
     * @param nr Nummer der Funktion
     */
    public static void setToolbarFunktionsart(int nr) {
        if (toolbar != null) toolbar.setFunktionsart(nr);
    }

    /**
     * Setzt die gewnschte Darstellungsart im Men
     *
     * @param nr Nummer der Funktion
     */
    public static void setMenueFunktionsart(int nr) {
        if (fenstermenue != null) fenstermenue.setFunktionsart(nr);
    }






    //*************** T H R E A D ************************************************
    static class RepaintThread extends Thread {
        public void run() {

            while (!isInterrupted()) {
                if (toolbar != null ) toolbar.doRepaint();
                try {
                    //Prozess schlft fr 5s.
                    Thread.sleep(60000);
                    if (Hauptfenster.isVisible() == false) {
                        thread.interrupt();
                    }

                } catch(InterruptedException e) {
                    thread.interrupt();
                }
            }
        }
    }
}


